package com.flyfish.framework.r2dbc.config;

import com.flyfish.framework.domain.base.Domain;
import org.reactivestreams.Publisher;
import org.springframework.data.r2dbc.mapping.event.AfterConvertCallback;
import org.springframework.data.relational.core.sql.SqlIdentifier;
import reactor.core.publisher.Mono;

/**
 * 给r2dbc中的实体进行关联填充
 *
 * @author wangyu
 */
public class R2dbcReferenceEntityCallback implements AfterConvertCallback<Domain> {

    /**
     * Entity callback method invoked after a domain object is materialized from a row. Can return either the same or a
     * modified instance of the domain object.
     *
     * @param entity the domain object (the result of the conversion).
     * @param table  name of the table.
     * @return the domain object that is the result of reading it from a row.
     */
    @Override
    public Publisher<Domain> onAfterConvert(Domain entity, SqlIdentifier table) {
        return Mono.just(entity);
    }
}
