package com.flyfish.framework.r2dbc.repository.fill;

import com.flyfish.framework.domain.base.Domain;
import org.springframework.data.r2dbc.convert.R2dbcConverter;
import org.springframework.data.relational.core.mapping.RelationalPersistentEntity;
import org.springframework.data.relational.repository.query.RelationalEntityInformation;
import org.springframework.data.util.Lazy;
import reactor.core.publisher.Mono;

public class SimpleR2dbcReferenceFiller<T extends Domain> implements R2dbcReferenceFiller<T> {

    private final Lazy<RelationalPersistentEntity<T>> persistentEntity;

    public SimpleR2dbcReferenceFiller(RelationalEntityInformation<T, String> entity, R2dbcConverter converter) {
        this.persistentEntity = Lazy.of(() -> (RelationalPersistentEntity<T>) converter
                .getMappingContext()
                .getRequiredPersistentEntity(entity.getJavaType()));
    }

    /**
     * 填充附加值
     *
     * @param bean 实体信息
     * @return 结果
     */
    @Override
    public Mono<T> fill(T bean) {
        return null;
    }
}
